unit SigmaZipU;

interface

uses
  Windows, SysUtils, Controls, Forms, Backup, Dialogs, StdCtrls, Buttons, ExtCtrls, FileCtrl, Grids, Classes;

type
  TFSigmaZip = class(TForm)
    Bevel1: TBevel;
    BitBtn1: TBitBtn;
    OpenDialog1: TOpenDialog;
    BitBtn2: TBitBtn;
    FileListBox1: TFileListBox;
    Label1: TLabel;
    Bevel2: TBevel;
    Bevel3: TBevel;
    BitBtn3: TBitBtn;
    BitBtn4: TBitBtn;
    RadioButton1: TRadioButton;
    RadioButton2: TRadioButton;
    Bevel4: TBevel;
    StringGrid1: TStringGrid;
    BackupFile1: TBackupFile;
    BitBtn5: TBitBtn;
    Memo1: TMemo;
    SaveDialog1: TSaveDialog;
    OpenDialog2: TOpenDialog;
    CheckBox1: TCheckBox;
    ContagemP: TPanel;
    ContagemT: TStaticText;
    procedure BitBtn1Click(Sender: TObject);
    procedure BitBtn2Click(Sender: TObject);
    procedure BitBtn3Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure BitBtn4Click(Sender: TObject);
    procedure BitBtn5Click(Sender: TObject);
    procedure BackupFile1Progress(Sender: TObject; Filename: String; Percent: TPercentage; var Continue: Boolean);
  private
    procedure Erros(Sender: TObject; E: Exception);
end;

var
  FSigmaZip: TFSigmaZip;
  Contador: Integer = 0;
  MultiUso: String;

implementation

uses DialogoU;

{$R *.DFM}

procedure Bloquear;
begin
  FSigmaZip.CheckBox1.Enabled:=FSigmaZip.CheckBox1.Enabled;
  FSigmaZip.BitBtn1.Enabled:=FSigmaZip.BitBtn1.Enabled=False;
  FSigmaZip.BitBtn2.Enabled:=FSigmaZip.BitBtn2.Enabled=False;
  FSigmaZip.BitBtn3.Enabled:=FSigmaZip.BitBtn3.Enabled=False;
  FSigmaZip.BitBtn4.Enabled:=FSigmaZip.BitBtn4.Enabled=False;
  FSigmaZip.BitBtn5.Enabled:=FSigmaZip.BitBtn5.Enabled=False;
  FSigmaZip.RadioButton1.Enabled:=FSigmaZip.RadioButton1.Enabled;
  FSigmaZip.RadioButton2.Enabled:=FSigmaZip.RadioButton2.Enabled;
  FSigmaZip.ContagemP.Visible:=FSigmaZip.ContagemP.Visible=False;
  FSigmaZip.Update;
end;

procedure ConfiguraComoInformacao;
begin
  Informacao.ShowModal;
  Informacao.Free;
  FSigmaZip.UpDate;
end;

procedure ConfiguraComoConfirmacao;
begin
  Informacao.Bevel6.Visible:=False;
  Informacao.Bevel5.Visible:=True;
  Informacao.Bevel4.Visible:=True;
  Informacao.Label6.Visible:=False;
  Informacao.Label5.Visible:=True;
  Informacao.Label4.Visible:=True;
  Informacao.Image2.Visible:=True;
  Informacao.Image3.Visible:=True;
  Informacao.Image4.Visible:=False;
  Informacao.Label2.Caption:='Confirmao';
  Informacao.Label3.Caption:='c';
  Informacao.ShowModal;
  Informacao.Free;
  FSigmaZip.UpDate;
end;

procedure TFSigmaZip.Erros(Sender: TObject; E: Exception);
var
  BcoDados: TextFile;
begin
  AssignFile(BcoDados,'C:\Porta Arquivos\Porta Arquivos\Erros.sgm');
  if not(FileExists('C:\Porta Arquivos\Porta Arquivos\Erros.sgm')) then Rewrite(BcoDados);
  Append(BcoDados);
  Writeln(BcoDados,FormatDateTime('DD/MM/YYYY HH:MM:SS',Now)+' - '+E.Message);
  CloseFile(BcoDados);
  Application.CreateForm(TInformacao, Informacao);
  Informacao.HelpContext:=100;
  Informacao.Label1.Caption:='Operao no definida!';
  ConfiguraComoInformacao;
  if not(Screen.ActiveForm.Visible) then Screen.ActiveForm.Close;
end;

procedure TFSigmaZip.FormCreate(Sender: TObject);
begin
  Application.OnException:=Erros;
end;

procedure TFSigmaZip.BitBtn4Click(Sender: TObject);
var
  Temp: Integer;
begin
  Memo1.Clear;
  if CheckBox1.Checked then BackupFile1.MaxSize:=1400000 else BackupFile1.MaxSize:=0;
  for Temp:=0 to StringGrid1.RowCount-1 do if Trim(StringGrid1.Cells[0,Temp])<>'' then Memo1.Lines.Add(StringGrid1.Cells[0,Temp]);
  if Memo1.Lines.Count=0 then Abort;
  if SaveDialog1.Execute then
    begin
      Update;
      Bloquear;
      BackupFile1.Backup(Memo1.Lines,SaveDialog1.FileName);
      Bloquear;
      Application.CreateForm(TInformacao, Informacao);
      Informacao.Label1.Caption:='Operao efetuada!';
      ConfiguraComoInformacao;
    end;
  Memo1.Clear;
end;

procedure TFSigmaZip.BitBtn5Click(Sender: TObject);
begin
  if OpenDialog1.Execute then
    begin
      Update;
      Bloquear;
      BackupFile1.Restore(OpenDialog1.FileName,'C:\Windows\Desktop\Sigma Zip');
      Bloquear;
      Application.CreateForm(TInformacao, Informacao);
      Informacao.Label1.Caption:='Operao efetuada!';
      ConfiguraComoInformacao;
    end;
end;

procedure TFSigmaZip.BitBtn1Click(Sender: TObject);
var
  Temp: Integer;
  Dir, Diretorio: String;
begin
  if RadioButton1.Checked and OpenDialog2.Execute then for Temp:=0 to OpenDialog2.Files.Count-1 do
    begin
      StringGrid1.Cells[0,Contador]:=OpenDialog2.Files.Strings[Temp];
      Inc(Contador);
      StringGrid1.RowCount:=Contador;
    end;
  if RadioButton2.Checked and SelectDirectory('Favor selecionar o diretrio de origem.',Diretorio,Dir) then
    begin
      FileListBox1.Directory:=Dir;
      FileListBox1.Update;
      if Length(Dir)>3 then Dir:=Dir+'\';
      for Temp:=0 to FileListBox1.Count-1 do
        begin
          StringGrid1.Cells[0,Contador]:=Dir+FileListBox1.Items[Temp];
          Inc(Contador);
          StringGrid1.RowCount:=Contador;
        end;
    end;
end;

procedure TFSigmaZip.BitBtn3Click(Sender: TObject);
begin
  if StringGrid1.Cells[0,StringGrid1.Row]='' then Abort;
  Application.CreateForm(TInformacao, Informacao);
  Informacao.HelpContext:=101;
  Informacao.Label1.Caption:='Voc tem certeza?';
  ConfiguraComoConfirmacao;
  StringGrid1.Cells[0,StringGrid1.Row]:='';
end;

procedure TFSigmaZip.BitBtn2Click(Sender: TObject);
begin
  Close;
end;

procedure TFSigmaZip.BackupFile1Progress(Sender: TObject; Filename: String; Percent: TPercentage; var Continue: Boolean);
begin
  if Percent<=100 then ContagemT.Caption:=IntToStr(100-Percent);
  if 100-Percent=0 then ContagemT.Caption:='Aguarde';
end;

end.
